--[[
Name: FlexBar 2
Revision: $Rev: SVN $
Author(s): Cncfanatics (cvcncfanatic@runemasters.net)
    Dhaggar (isheridan@savagevines.com)
Website: http://flexdev.mmorpgaming.com
Documentation: http://flexdev.mmorpgaming.com/index.php?n=Main.Docs
Description: Makes your 120 actionbuttons incredibly versatile
Dependencies: AceLibrary
]]



FlexBar2 = AceLibrary("AceAddon-2.0"):new("AceModuleCore-2.0", "AceEvent-2.0", "AceDebug-2.0", "AceDB-2.0", "AceConsole-2.0", "AceHook-2.1"); -- Load ace2 with the needed mixins
FlexBar2.OO = AceLibrary("AceOO-2.0"); -- Load AceOO
function FlexBar2:OnInitialize() -- Called with the ADDON_LOADED event (this ensures the code here gets executed before any modules are loaded)
	FlexBar2:RegisterDB("FlexBar2_DB"); -- Register the database
	FlexBar2:RegisterDefaults('profile', {}); -- Default state of the database (an empty table :p)
	FlexBar2:SetDebugging(false); -- This will make all the :Debug messages hide themselves
end
function FlexBar2:OnEnable() -- Called with the PLAYER_LOGIN event, or when we get out of standby mode
	FlexBar2.Model:Startup();
	FlexBar2.Controller:Startup();
end
function FlexBar2:OnDisable() -- Called when we enter standby mode
	
end
function FlexBar2:ToString() -- Called when using tostring(FlexBar2)
	return "FlexBar2";
end

function FlexBar2:TableCopy(t)
	local n = {}
	for k,v in pairs(t) do
		n[k] = v;
	end
	return n;
end

function FlexBar2:RemoveByVal(tab, val)
	if(type(tab) ~= "table") then return false; end
	for k,v in pairs(tab) do
		if(v==val) then
			table.remove(tab, k);
			return true;
		end
	end
	return false;
end

function FlexBar2:ValIsInTable(tab, val)
	if(type(tab) ~= "table") then return false; end
	for k,v in pairs(tab) do
		if(v==val) then
			return true;
		end
	end
	return false;
end

function FlexBar2:GetItemInfoByName(name)
	local bag, slot, texture, ItemCount, locked, quality, readable, RetBag, RetSlot, RetItemCount, ItemName, ItemLink, _;
	RetBag = {};
	RetSlot = {};
	RetItemCount = 0;
	for bag = 0, 4 do
		for slot = 1,GetContainerNumSlots(bag) do
			ItemLink = GetContainerItemLink(bag, slot);
			if(ItemLink and string.find(GetContainerItemLink(bag, slot), name)) then
				table.insert(RetBag, bag);
				table.insert(RetSlot, slot);
				texture, ItemCount, locked, quality, readable = GetContainerItemInfo(bag, slot);
				RetItemCount = RetItemCount + ItemCount;
			end
		end
	end
	return texture, RetItemCount, locked, quality, readable, RetBag, RetSlot, name, ItemLink;
end
