--[[
Name: FlexBar 2
Revision: $Rev: SVN $
Author(s): Cncfanatics (cvcncfanatic@runemasters.net)
    Dhaggar (isheridan@savagevines.com)
Website: http://flexdev.mmorpgaming.com
Documentation: http://flexdev.mmorpgaming.com/index.php?n=Main.Docs
Description: Makes your 120 actionbuttons incredibly versatile
Dependencies: AceLibrary
]]
FlexBar2.Model = {};
function FlexBar2.Model:Startup()
	--FlexBar2.Model:Reset(); -- Reset FlexBar2 as it starts up (this is debugging code, of course)
end

function FlexBar2.Model:Reset()
	FlexBar2.db.profile.ButtonSettings = nil;
	FlexBar2.db.profile.CustomSettings = nil;
end

function FlexBar2.Model:IsEmpty()
	if(not FlexBar2.db.profile.ButtonSettings or not FlexBar2.db.profile.CustomSettings) then
		return true;
	else
		return false;
	end
end

function FlexBar2.Model:GetButtonSetting(button, setting) -- Get a single setting of a button from database
	if(type(FlexBar2.db.profile.ButtonSettings) == "table" and type(FlexBar2.db.profile.ButtonSettings[button]) == "table") then
		return FlexBar2.db.profile.ButtonSettings[button][setting];
	else
		return nil;
	end
end

function FlexBar2.Model:SetButtonSetting(button, setting, value) --Set a single setting for a button 
	if(type(FlexBar2.db.profile.ButtonSettings) ~= "table") then FlexBar2.db.profile.ButtonSettings = {}; end
	if(type(button) ~= "number") then return; end;
	if(type(FlexBar2.db.profile.ButtonSettings[button]) ~= "table") then FlexBar2.db.profile.ButtonSettings[button] = {}; end
	FlexBar2.db.profile.ButtonSettings[button][setting] = value;
	return true;
end

function FlexBar2.Model:GetAllButtonSettings(button) -- Gets all the settings of a button from database
	if(type(FlexBar2.db.profile.ButtonSettings) == "table") then
		return FlexBar2.db.profile.ButtonSettings[button];
	else
		return nil;
	end
end

function FlexBar2.Model:SetAllButtonSettings(button, settings) --Set all settings of a button
	if(type(settings) ~= "table") then return nil; end
	if(type(FlexBar2.db.profile.ButtonSettings) ~= "table") then FlexBar2.db.profile.ButtonSettings = {}; end
	FlexBar2.db.profile.ButtonSettings[button] = settings;
end

function FlexBar2.Model:SetCustomSetting(setting, value) -- Set a custom setting to be saved across sessions
	if(type(FlexBar2.db.profile.CustomSettings) ~= "table") then FlexBar2.db.profile.CustomSettings = {}; end
	FlexBar2.db.profile.CustomSettings[setting] = value;
	return true;
end

function FlexBar2.Model:GetCustomSetting(setting) -- Get a custom setting
	if(type(FlexBar2.db.profile.CustomSettings) ~= "table") then FlexBar2.db.profile.CustomSettings = {}; end
	return FlexBar2.db.profile.CustomSettings[setting];
end


function FlexBar2.Model:GetTempData(key) -- Get a temporary setting
	if(type(FlexBar2.tmp) == "table") then
		return FlexBar2.tmp[key];
	else
		return nil
	end
end

function FlexBar2.Model:SetTempData(key, value) -- Set a temporary setting (will NOT be saved across sessions)
	if(type(FlexBar2.tmp) ~= "table") then FlexBar2.tmp = {}; end
	FlexBar2.tmp[key] = value;
	return true;
end
